import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Ein Auswahlfenster fr Kumpanen, Zeugen usw.
 * 
 * @author Bernd Gramlich 
 * @version 2013-05-01
 */
public class Auswahlfenster implements ActionListener
{
    private JFrame fenster;
    private JPanel fensterraum;
    private JButton tatortknopf;
    private JButton kumpanenknopf;
    private JButton zeugenknopf;
    private JButton opferknopf;
    private JButton taeterknopf;
    private Bildfenster anzeige;
    
    private static String[] tatort  = {"IMG_1223.jpg"};
    private static String[] kumpane = {"Anna, Kumpane.jpg", "chrissi,Kumpane.jpg", "Dina, Kumpane.jpg", 
        "Franzi,Kumpane.jpg", "Madlena,Kumpane.jpg", "Nicole,Kumpane.jpg", "Steffi, Kumpane.jpg"};
    private static String[] zeuge  = {"Co, lab1,2,3, 4. Zeuge.jpg", "Dani, lab 1,2,3, 3. Zeuge.jpg",
        "Hanna, lab1,2,3, 1.Zeuge.jpg", "Inken, lab2,2. Zeuge.JPG", "Inken,lab1u.3, 2. Zeuge.jpg",
        "Kim, lab1, 5. Zeuge .jpg", "Kim, lab2,5.zeuge.JPG", "Kim, lab3,5.zeuge.JPG",
        "Laura, lab1,2,3, 6. zeuge.jpg"};
    private static String[] opfer  = {"feli, lab 1,2,3, oper 2.jpg", "lisa, lab1,2,3, opfer 1.jpg"};
    private static String[] taeter = {"IMG_1187b.JPG"};
    
    private int[] tatortzahl   = new int[tatort.length];
    private int[] kumpanenzahl = new int[kumpane.length];
    private int[] zeugenzahl   = new int[zeuge.length];
    private int[] opferzahl    = new int[opfer.length];
    private int[] taeterzahl   = new int[taeter.length];
    
    /**
     * Konstruktor.
     * Erzeuge das Auswahlfenster.
     */
    public Auswahlfenster ()
    {
        tatortknopf   = new JButton ("Tatort");
        kumpanenknopf = new JButton ("Kumpane");
        zeugenknopf   = new JButton ("Zeuge");
        opferknopf    = new JButton ("Opfer");
        taeterknopf   = new JButton ("Taeter");
        tatortknopf.addActionListener (this);
        kumpanenknopf.addActionListener (this);
        zeugenknopf.addActionListener (this);
        opferknopf.addActionListener (this);
        taeterknopf.addActionListener (this);
        
        fensterraum = new JPanel (new GridLayout (5, 1));
        fensterraum.add (tatortknopf);
        fensterraum.add (kumpanenknopf);
        fensterraum.add (zeugenknopf);
        fensterraum.add (opferknopf);
        fensterraum.add (taeterknopf);
        
        fenster = new JFrame ("Auswahl");
        fenster.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
        fenster.getContentPane ().add (fensterraum);
        fenster.pack ();
        fenster.setLocationRelativeTo (null);
        fenster.setVisible (true);
    }
    
    /**
     * Reagiere auf Benutzeraktionen.
     */
    public void actionPerformed (ActionEvent ereignis)
    {
        if (ereignis.getSource () == tatortknopf)
        {
            anzeige = new Bildfenster (fenster, "Tatort", ziehe (tatort, tatortzahl));
        }
        else if (ereignis.getSource () == kumpanenknopf)
        {
            anzeige = new Bildfenster (fenster, "Kumpane", ziehe (kumpane, kumpanenzahl));
        }
        else if (ereignis.getSource () == zeugenknopf)
        {
            anzeige = new Bildfenster (fenster, "Zeuge", ziehe (zeuge, zeugenzahl));
        }
        else if (ereignis.getSource () == opferknopf)
        {
            anzeige = new Bildfenster (fenster, "Opfer", ziehe (opfer, opferzahl));
        }
        else if (ereignis.getSource () == taeterknopf)
        {
            anzeige = new Bildfenster (fenster, "Taeter", ziehe (taeter, taeterzahl));
        }
    }
    
    /**
     * Ziehe ohne Zuruecklegen aus dem Feld bildname.
     * Speichere dabei im Feld bildzahl, wie oft Du jeden bildnamen schon gezogen hast.
     * Wenn alle Bilder einmal dran waren, ziehe wieder aus dem gesamten Vorrat.
     */
    private String ziehe (String[] bildname, int[] bildzahl)
    {
        int laenge  = bildzahl.length;
        int minimum = bildzahl[0];
        int passend = 1;
        
        for (int i = 1; i < laenge; i++)
        {
           if (bildzahl[i] < minimum)
           {
               minimum = bildzahl[i];
               passend = 1;
           }
           else if (bildzahl[i] == minimum)
           {
               passend++;
           }
        }
        
        String ausgabe = "";
        
        int nummer = (int) Math.floor (passend * Math.random ());
        int j      = 0;
        
        for (int i = 0; i < laenge; i++)
        {
            if (bildzahl [i] == minimum)
            {
                if (j++ == nummer)
                {
                    ausgabe = bildname[i];
                    bildzahl[i] ++;
                }
            }
        }
        
        return ausgabe;
    }
}
